diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet-apps/model/ping6.cc ns-3.34/src/internet-apps/model/ping6.cc
--- ns-3.33/src/internet-apps/model/ping6.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet-apps/model/ping6.cc	2021-07-14 10:31:06.000000000 -0700
@@ -26,7 +26,6 @@
 #include "ns3/packet.h"
 #include "ns3/socket.h"
 #include "ns3/uinteger.h"
-#include "ns3/ipv6.h"
 #include "ns3/inet6-socket-address.h"
 #include "ns3/icmpv6-header.h"
 #include "ns3/ipv6-raw-socket-factory.h"
@@ -82,6 +81,8 @@
   m_sent = 0;
   m_socket = 0;
   m_seq = 0;
+  m_ipInterfaceIndex = 0;
+  m_ifIndex = 0;
   m_sendEvent = EventId ();
 }
 
@@ -111,6 +112,12 @@
       m_socket->Bind (Inet6SocketAddress (m_localAddress, 0));
       m_socket->SetAttribute ("Protocol", UintegerValue (Ipv6Header::IPV6_ICMPV6));
       m_socket->SetRecvCallback (MakeCallback (&Ping6::HandleRead, this));
+      m_ipv6Protocol = m_node->GetObject<Ipv6L3Protocol> ();
+
+      if (!m_localAddress.IsAny ())
+        {
+          m_ipInterfaceIndex = m_ipv6Protocol->GetInterfaceForAddress (m_localAddress);
+        }
     }
 
   ScheduleTransmit (Seconds (0.));
@@ -270,6 +277,16 @@
                            " id =  " << (uint16_t)reply.GetId () <<
                            " seq = " << (uint16_t)reply.GetSeq () <<
                            " Hop Count = " << (uint16_t) (64 - hdr.GetHopLimit ()));
+
+              if (m_ifIndex)
+                {
+                  m_ipv6Protocol->ReachabilityHint (m_ifIndex, address.GetIpv6 ());
+                }
+              else
+                {
+                  m_ipv6Protocol->ReachabilityHint (m_ipInterfaceIndex, address.GetIpv6 ());
+                }
+
               break;
             case Icmpv6Header::ICMPV6_ERROR_DESTINATION_UNREACHABLE:
               packet->RemoveHeader (destUnreach);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet-apps/model/ping6.h ns-3.34/src/internet-apps/model/ping6.h
--- ns-3.33/src/internet-apps/model/ping6.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet-apps/model/ping6.h	2021-07-14 10:31:06.000000000 -0700
@@ -23,6 +23,7 @@
 
 #include "ns3/application.h"
 #include "ns3/ipv6-address.h"
+#include "ns3/ipv6-l3-protocol.h"
 
 namespace ns3
 {
@@ -139,7 +140,7 @@
   uint32_t m_size;
 
   /**
-   * \brief Intervall between packets sent.
+   * \brief Interval between packets sent.
    */
   Time m_interval;
 
@@ -149,6 +150,16 @@
   Ipv6Address m_localAddress;
 
   /**
+   * \brief IP interface index relative to the local address.
+   */
+  uint32_t m_ipInterfaceIndex;
+
+  /**
+   * \brief IP interface index relative to the local address.
+   */
+  Ptr<Ipv6L3Protocol> m_ipv6Protocol;
+
+  /**
    * \brief Peer address.
    */
   Ipv6Address m_peerAddress;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet-apps/model/radvd.cc ns-3.34/src/internet-apps/model/radvd.cc
--- ns-3.33/src/internet-apps/model/radvd.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet-apps/model/radvd.cc	2021-07-14 10:31:06.000000000 -0700
@@ -227,17 +227,17 @@
 
       if ((*jt)->IsOnLinkFlag ())
         {
-          flags += 1 << 7;
+          flags |= Icmpv6OptionPrefixInformation::ONLINK;
         }
 
       if ((*jt)->IsAutonomousFlag ())
         {
-          flags += 1 << 6;
+          flags |= Icmpv6OptionPrefixInformation::AUTADDRCONF;
         }
 
       if ((*jt)->IsRouterAddrFlag ())
         {
-          flags += 1 << 5;
+          flags |= Icmpv6OptionPrefixInformation::ROUTERADDR;
         }
 
       prefixHdr.SetFlags (flags);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet-apps/model/v4traceroute.h ns-3.34/src/internet-apps/model/v4traceroute.h
--- ns-3.33/src/internet-apps/model/v4traceroute.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet-apps/model/v4traceroute.h	2021-07-14 10:31:06.000000000 -0700
@@ -59,6 +59,7 @@
   virtual ~V4TraceRoute ();
   /**
    * \brief Prints the application traced routes into a given OutputStream.
+   * \param stream the output stream
    */
   void Print (Ptr<OutputStreamWrapper> stream);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet-apps/test/ipv6-radvd-test.cc ns-3.34/src/internet-apps/test/ipv6-radvd-test.cc
--- ns-3.33/src/internet-apps/test/ipv6-radvd-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/internet-apps/test/ipv6-radvd-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -0,0 +1,278 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2021 Universita' di Firenze, Italy
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ *
+ */
+
+#include "ns3/data-rate.h"
+#include "ns3/simple-net-device.h"
+#include "ns3/simple-net-device-helper.h"
+#include "ns3/internet-stack-helper.h"
+#include "ns3/ipv6-address-helper.h"
+#include "ns3/ipv6-routing-protocol.h"
+#include "ns3/ipv6-routing-helper.h"
+#include "ns3/ipv6-route.h"
+#include "ns3/radvd-helper.h"
+#include "ns3/test.h"
+
+using namespace ns3;
+
+/**
+ * \ingroup radvd
+ * \defgroup radvd-test radvd tests
+ */
+
+
+/**
+ * \ingroup radvd-test
+ * \ingroup tests
+ *
+ * \brief radvd basic tests
+ */
+class RadvdTestCase : public TestCase
+{
+public:
+  RadvdTestCase ();
+  virtual ~RadvdTestCase ();
+
+private:
+  virtual void DoRun (void);
+
+  /**
+   * Checks the addresses on the selected NetDevices.
+   * \param n0Dev node 0 device
+   * \param r0Dev router device toward node 0
+   * \param r1Dev router device toward node 1
+   * \param n1Dev node 1 device
+   */
+  void CheckAddresses (Ptr<NetDevice> n0Dev, Ptr<NetDevice> r0Dev, Ptr<NetDevice> r1Dev, Ptr<NetDevice> n1Dev);
+  /**
+   * Checks the routing between the selected NetDevices.
+   * \param n0Dev node 0 device
+   * \param r0Dev router device toward node 0
+   * \param r1Dev router device toward node 1
+   * \param n1Dev node 1 device
+   */
+  void CheckRouting (Ptr<NetDevice> n0Dev, Ptr<NetDevice> r0Dev, Ptr<NetDevice> r1Dev, Ptr<NetDevice> n1Dev);
+
+  std::vector<Ipv6Address> m_addresses; //!< Addresses on the nodes
+  std::vector<Socket::SocketErrno> m_routingResults; //!< Routing call return values
+  std::vector<Ptr<Ipv6Route> > m_routes; //!< Routing call results
+};
+
+RadvdTestCase::RadvdTestCase ()
+  : TestCase ("Radvd test case ")
+{
+}
+
+RadvdTestCase::~RadvdTestCase ()
+{
+}
+
+void
+RadvdTestCase::CheckAddresses (Ptr<NetDevice> n0Dev, Ptr<NetDevice> r0Dev, Ptr<NetDevice> r1Dev, Ptr<NetDevice> n1Dev)
+{
+  Ptr<Ipv6L3Protocol> ipv6;
+
+  ipv6 = n0Dev->GetNode ()->GetObject<Ipv6L3Protocol> ();
+  m_addresses.push_back (ipv6->GetAddress (ipv6->GetInterfaceForDevice (n0Dev), 1).GetAddress ());
+
+  ipv6 = r0Dev->GetNode ()->GetObject<Ipv6L3Protocol> ();
+  m_addresses.push_back (ipv6->GetAddress (ipv6->GetInterfaceForDevice (r0Dev), 1).GetAddress ());
+
+  ipv6 = r1Dev->GetNode ()->GetObject<Ipv6L3Protocol> ();
+  m_addresses.push_back (ipv6->GetAddress (ipv6->GetInterfaceForDevice (r1Dev), 1).GetAddress ());
+
+  ipv6 = n1Dev->GetNode ()->GetObject<Ipv6L3Protocol> ();
+  m_addresses.push_back (ipv6->GetAddress (ipv6->GetInterfaceForDevice (n1Dev), 1).GetAddress ());
+}
+
+void
+RadvdTestCase::CheckRouting (Ptr<NetDevice> n0Dev, Ptr<NetDevice> r0Dev, Ptr<NetDevice> r1Dev, Ptr<NetDevice> n1Dev)
+{
+  Ptr<Ipv6L3Protocol> ipv6;
+  Ptr<Packet> p = Create<Packet> ();
+  Ipv6Header ipHdr;
+  Socket::SocketErrno sockerr;
+  Ptr<Ipv6Route> route;
+
+  ipv6 = n0Dev->GetNode ()->GetObject<Ipv6L3Protocol> ();
+  ipHdr.SetSourceAddress (m_addresses[0]);
+  ipHdr.SetDestinationAddress (m_addresses[1]);
+  route = ipv6->GetRoutingProtocol ()->RouteOutput (p, ipHdr, n0Dev, sockerr);
+  m_routingResults.push_back (sockerr);
+  m_routes.push_back (route);
+
+  ipv6 = r0Dev->GetNode ()->GetObject<Ipv6L3Protocol> ();
+  ipHdr.SetSourceAddress (m_addresses[1]);
+  ipHdr.SetDestinationAddress (m_addresses[0]);
+  route = ipv6->GetRoutingProtocol ()->RouteOutput (p, ipHdr, r0Dev, sockerr);
+  m_routingResults.push_back (sockerr);
+  m_routes.push_back (route);
+
+  ipv6 = r1Dev->GetNode ()->GetObject<Ipv6L3Protocol> ();
+  ipHdr.SetSourceAddress (m_addresses[2]);
+  ipHdr.SetDestinationAddress (m_addresses[3]);
+  route = ipv6->GetRoutingProtocol ()->RouteOutput (p, ipHdr, r1Dev, sockerr);
+  m_routingResults.push_back (sockerr);
+  m_routes.push_back (route);
+
+  ipv6 = n1Dev->GetNode ()->GetObject<Ipv6L3Protocol> ();
+  ipHdr.SetSourceAddress (m_addresses[3]);
+  ipHdr.SetDestinationAddress (m_addresses[2]);
+  route = ipv6->GetRoutingProtocol ()->RouteOutput (p, ipHdr, n1Dev, sockerr);
+  m_routingResults.push_back (sockerr);
+  m_routes.push_back (route);
+}
+
+void
+RadvdTestCase::DoRun (void)
+{
+   // Create nodes
+  Ptr<Node> n0 = CreateObject<Node> ();
+  Ptr<Node> r = CreateObject<Node> ();
+  Ptr<Node> n1 = CreateObject<Node> ();
+
+  NodeContainer net1 (n0, r);
+  NodeContainer net2 (r, n1);
+  NodeContainer all (n0, r, n1);
+
+  // Create IPv6 Internet Stack
+  InternetStackHelper internetv6;
+  internetv6.Install (all);
+
+  // Create channels
+  SimpleNetDeviceHelper simpleNetDevice;
+  simpleNetDevice.SetChannelAttribute ("Delay", TimeValue (MilliSeconds (2)));
+  simpleNetDevice.SetDeviceAttribute ("DataRate", DataRateValue (DataRate ("5Mbps")));
+
+  NetDeviceContainer d1 = simpleNetDevice.Install (net1); /* n0 - R */
+  NetDeviceContainer d2 = simpleNetDevice.Install (net2); /* R - n1 */
+
+  // Create networks and assign IPv6 Addresses
+  Ipv6AddressHelper ipv6;
+
+  /* first subnet */
+  ipv6.SetBase (Ipv6Address ("2001:1::"), Ipv6Prefix (64));
+  NetDeviceContainer tmp;
+  tmp.Add (d1.Get (0)); /* n0 */
+  Ipv6InterfaceContainer iic1 = ipv6.AssignWithoutAddress (tmp); /* n0 interface */
+
+  NetDeviceContainer tmp2;
+  tmp2.Add (d1.Get (1)); /* R */
+  Ipv6InterfaceContainer iicr1 = ipv6.AssignWithoutOnLink (tmp2); /* R interface to the first subnet is just statically assigned */
+  iicr1.SetForwarding (0, true);
+  iic1.Add (iicr1);
+
+  /* second subnet R - n1 */
+  ipv6.SetBase (Ipv6Address ("2001:2::"), Ipv6Prefix (64));
+  NetDeviceContainer tmp3;
+  tmp3.Add (d2.Get (0)); /* R */
+  Ipv6InterfaceContainer iicr2 = ipv6.Assign (tmp3); /* R interface */
+  iicr2.SetForwarding (0, true);
+
+  NetDeviceContainer tmp4;
+  tmp4.Add (d2.Get (1)); /* n1 */
+  Ipv6InterfaceContainer iic2 = ipv6.AssignWithoutAddress (tmp4);
+  iic2.Add (iicr2);
+
+  /* radvd configuration */
+  RadvdHelper radvdHelper;
+
+  /* R interface (n0 - R) */
+  /* n0 will receive unsolicited (periodic) RA */
+  radvdHelper.AddAnnouncedPrefix (iic1.GetInterfaceIndex (1), Ipv6Address("2001:1::0"), 64);
+  Ptr<RadvdPrefix> prefix = *(radvdHelper.GetRadvdInterface (iic1.GetInterfaceIndex (1))->GetPrefixes ().begin ());
+  prefix->SetOnLinkFlag (false);
+
+  /* R interface (R - n1) */
+  /* n1 will have to use RS, as RA are not sent automatically */
+  radvdHelper.AddAnnouncedPrefix(iic2.GetInterfaceIndex (1), Ipv6Address("2001:2::0"), 64);
+  radvdHelper.GetRadvdInterface (iic2.GetInterfaceIndex (1))->SetSendAdvert (false);
+
+  ApplicationContainer radvdApps = radvdHelper.Install (r);
+  radvdApps.Start (Seconds (1.0));
+  radvdApps.Stop (Seconds (10.0));
+
+  Simulator::Schedule (Seconds (2), &RadvdTestCase::CheckAddresses, this, d1.Get (0), d1.Get (1), d2.Get (0), d2.Get (1));
+  Simulator::Schedule (Seconds (3), &RadvdTestCase::CheckRouting, this, d1.Get (0), d1.Get (1), d2.Get (0), d2.Get (1));
+
+
+  Simulator::Stop (Seconds (10.0));
+
+  Simulator::Run ();
+
+  // Address assignment checks
+  NS_TEST_ASSERT_MSG_EQ (m_addresses[0], Ipv6Address ("2001:1::200:ff:fe00:1"),
+                         m_addresses[0] << " instead of " << "2001:1::200:ff:fe00:1");
+
+  NS_TEST_ASSERT_MSG_EQ (m_addresses[1], Ipv6Address ("2001:1::200:ff:fe00:2"),
+                         m_addresses[1] << " instead of " << "2001:1::200:ff:fe00:2");
+
+  NS_TEST_ASSERT_MSG_EQ (m_addresses[2], Ipv6Address ("2001:2::200:ff:fe00:3"),
+                         m_addresses[2] << " instead of " << "2001:2::200:ff:fe00:3");
+
+  NS_TEST_ASSERT_MSG_EQ (m_addresses[3], Ipv6Address ("2001:2::200:ff:fe00:4"),
+                         m_addresses[3] << " instead of " << "2001:2::200:ff:fe00:4");
+
+  // Routes checks
+  NS_TEST_ASSERT_MSG_EQ (m_routingResults[0], Socket::ERROR_NOTERROR,
+                         (int) m_routingResults[0] << " instead of Socket::ERROR_NOTERROR");
+
+  NS_TEST_ASSERT_MSG_EQ (m_routes[0]->GetGateway (), Ipv6Address ("fe80::200:ff:fe00:2"),
+                         m_routes[0]->GetGateway () << " instead of " << "fe80::200:ff:fe00:2");
+
+  NS_TEST_ASSERT_MSG_EQ (m_routingResults[1], Socket::ERROR_NOROUTETOHOST,
+                         (int) m_routingResults[1] << " instead of Socket::ERROR_NOROUTETOHOST");
+
+  NS_TEST_ASSERT_MSG_EQ (m_routingResults[2], Socket::ERROR_NOTERROR,
+                         (int) m_routingResults[2] << " instead of Socket::ERROR_NOTERROR");
+
+  NS_TEST_ASSERT_MSG_EQ (m_routes[2]->GetGateway (), Ipv6Address ("::"),
+                         m_routes[2]->GetGateway () << " instead of " << "::");
+
+  NS_TEST_ASSERT_MSG_EQ (m_routingResults[3], Socket::ERROR_NOTERROR,
+                         (int) m_routingResults[3] << " instead of Socket::ERROR_NOTERROR");
+
+  NS_TEST_ASSERT_MSG_EQ (m_routes[3]->GetGateway (), Ipv6Address ("::"),
+                         m_routes[3]->GetGateway () << " instead of " << "::");
+
+
+  Simulator::Destroy ();
+}
+
+/**
+ * \ingroup radvd-test
+ * \ingroup tests
+ *
+ * \brief radvd TestSuite
+ */
+class RadvdTestSuite : public TestSuite
+{
+public:
+  RadvdTestSuite ();
+};
+
+RadvdTestSuite::RadvdTestSuite ()
+  : TestSuite ("radvd", UNIT)
+{
+  AddTestCase (new RadvdTestCase, TestCase::QUICK);
+}
+
+static RadvdTestSuite radvdTestSuite; //!< Static variable for test initialization
+
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet-apps/wscript ns-3.34/src/internet-apps/wscript
--- ns-3.33/src/internet-apps/wscript	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet-apps/wscript	2021-07-14 10:31:06.000000000 -0700
@@ -28,6 +28,7 @@
     applications_test = bld.create_ns3_module_test_library('internet-apps')
     applications_test.source = [
         'test/dhcp-test.cc',
+        'test/ipv6-radvd-test.cc',
         ]
 
     # Tests encapsulating example programs should be listed here
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lr-wpan/bindings/callbacks_list.py ns-3.34/src/lr-wpan/bindings/callbacks_list.py
--- ns-3.33/src/lr-wpan/bindings/callbacks_list.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lr-wpan/bindings/callbacks_list.py	2021-07-14 10:31:06.000000000 -0700
@@ -16,6 +16,7 @@
     ['void', 'ns3::MlmeBeaconNotifyIndicationParams', 'ns3::Ptr<ns3::Packet>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::MlmeSyncLossIndicationParams', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::MlmePollConfirmParams', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'unsigned char', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::LrWpanMacState', 'ns3::LrWpanMacState', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::SuperframeStatus', 'ns3::SuperframeStatus', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
